<?php

class PluginAmasons3_ModuleTopic extends PluginAmasons3_Inherit_ModuleTopic {
	
	public function UploadTopicPhoto($aFile) {
		if(!is_array($aFile) || !isset($aFile['tmp_name'])) {
			return false;
		}

		$sFileName = func_generator(10);
		$sPath = Config::Get('path.uploads.images').'/topic/'.date('Y/m/d').'/';
		
		if (!is_dir(Config::Get('path.root.server').$sPath)) {
			mkdir(Config::Get('path.root.server').$sPath, 0755, true);
		}

		$sFileTmp = Config::Get('path.root.server').$sPath.$sFileName;
		if (!move_uploaded_file($aFile['tmp_name'],$sFileTmp)) {
			return false;
		}
		
		
		$aParams=$this->Image_BuildParams('photoset');

		$oImage = new LiveImage($sFileTmp);

        // Если объект изображения не создан,
        // возвращаем ошибку
		if($sError=$oImage->get_last_error()) {
			// Вывод сообщения об ошибки, произошедшей при создании объекта изображения
			$this->Message_AddError($sError,$this->Lang_Get('error'));
			@unlink($sFileTmp);
			return false;
		}

		// Превышает максимальные размеры из конфига
		if (($oImage->get_image_params('width')>Config::Get('view.img_max_width')) or ($oImage->get_image_params('height')>Config::Get('view.img_max_height'))) {
				$this->Message_AddError($this->Lang_Get('topic_photoset_error_size'),$this->Lang_Get('error'));
				@unlink($sFileTmp);
				return false;
		}
		
		// Добавляем к загруженному файлу расширение
		$sFile=$sFileTmp.'.'.$oImage->get_image_params('format');
		rename($sFileTmp,$sFile);
		
		$aSizes=Config::Get('module.topic.photoset.size');
		
		foreach ($aSizes as $aSize) {
			// Для каждого указанного в конфиге размера генерируем картинку
			$sNewFileName = $sFileName.'_'.$aSize['w'];
			$oImage = new LiveImage($sFile);
			if ($aSize['crop']) {
				$this->Image_CropProportion($oImage, $aSize['w'], $aSize['h'], true);
				$sNewFileName .= 'crop';
			}
			$this->Image_Resize($sFile,$sPath,$sNewFileName,Config::Get('view.img_max_width'),Config::Get('view.img_max_height'),$aSize['w'],$aSize['h'],true,$aParams,$oImage);
		}

		$sServerPath = rtrim(str_replace(DIRECTORY_SEPARATOR,'/',Config::Get('path.root.server')),'/');
		$sWebPath    = rtrim("http://" . Config::Get ( 'plugin.amasons3.bucketName' ) .  Config::Get ( 'plugin.amasons3.amason_suffix_url' ), '/');
		$res = str_replace($sServerPath, $sWebPath, str_replace(DIRECTORY_SEPARATOR,'/',$sFile));

		return $res;

	}
}

?>
